/* entrada.cpp */

#include <string.h>
#include <stdio.h>
#include <conio.h>
#include "tela.h"
#include "arquivo.h"
#include "definic.h"
#include "cria_fmt.h"


/*--------------------------------------------------------------------------*\
 | arquivo_entrada - Executa a entrada do nome do arquivo. Se ele exister   |
 |                   ela o le, caso contrario e requisitado se o usuario    |
 |                   deseja criar o arquivo.                                |
 |                                                                          |
 | Recebe - Nada.                                                           |
 |                                                                          |
 | Retorna - O formato do arquivo desejado e o seu respectivo nome.         |
\*--------------------------------------------------------------------------*/


char *arquivo_entrada (formato_arquivo &fmt)
{
  tela entrada (TELA_50_LINHAS, SISTEMA, "TELA INICIAL");
  char *nome_arquivo = new char [15];
  FILE *verif;

  strcpy (nome_arquivo, "");
  do {
    entrada.poe_mensagem ("Digite o nome do arquivo sem extensao.");
    entrada.escreve_esquerda (20, "Arquivo : ");
    if (entrada.edita_campo (15, 20, nome_arquivo, 8) == SAI){
      delete nome_arquivo;
      return NULL;
    }
    entrada.apaga_mensagem ();

    char nome_teste [15];
    strcpy (nome_teste, nome_arquivo);
    strcat (nome_teste, EXTENSAO_FORMATO);
    if ((verif = fopen (nome_teste, "r")) != NULL){
      fclose (verif);
      le_formato (nome_teste, fmt);
      return nome_arquivo;
    } else
      if (entrada.confirmacao ("O arquivo nao existe, deseja cria-lo ? ")
	  == SIM) {
	if (cria_formato (nome_arquivo, fmt) == SAI)
	  return NULL;
	return nome_arquivo;
      }
  } while (VERDADEIRO);
}




