/* tela.h */

#define CONTINUAR   " [ENTER]."
#define CONFIRMACAO " (S/N)? "

#define ENTER           7181
#define ESC              283
#define BACKSPACE       3592
#define SETA_CIMA      18432
#define SETA_BAIXO     20480
#define SETA_ESQUERDA  19200
#define SETA_DIREITA   19712

#define NULO    '\0'

#define SIM     1
#define NAO     0

#define SOBE    1
#define DESCE   2
#define SAI     3

#define MOLD_SIMPLES           6
#define MOLD_DUPLO_AMBAS       1
#define MOLD_DUPLO_VERT        3
#define MOLD_DUPLH_HOR         4
#define MOLD_CHEIO_FRACO       5
#define MOLD_CHEIO_MED         2
#define MOLD_CHEIO_FORTE       7
#define MOLD_CHEIO_COMPL       8

#define VERDADE    1
#define ERRO       0

#define APAGADA    0

#define MODO_INVALIDO   -1
#define TELA_25_LINHAS   0
#define TELA_50_LINHAS   1

class tela {

protected:

  char *cpz_titulo_tela;

  struct text_info sti_modo_ant;

  int i_tipo_tela,
      i_linha_mensagem;

  void tela_25 (const char *cpz_nome_sistema, const char *cpz_titulo);

  void tela_50 (const char *cpz_nome_sistema, const char *cpz_titulo);

public:

  tela (int i_modo, const char *cpz_nome_sistema, const char *cpz_titulo);

  void moldura (const int X1, const int Y1, const int X2, const int Y2,
		const int i_tipo);

  void escreve_esquerda (const int i_linha, const char *cpz_informacao);
  void escreve_meio     (const int i_linha, const char *cpz_informacao);
  void escreve_direita  (const int i_linha, const char *cpz_informacao);

  void escreve (int i_coluna, int i_linha, char *cpz_formato,
		char *cpz_informacao);
  void escreve (int i_coluna, int i_linha, char *cpz_formato,
		int cpz_informacao);
  void escreve (int i_coluna, int i_linha, char *cpz_formato,
		long int l_informacao);
  void escreve (int i_coluna, int i_linha, char *cpz_formato,
		char cpz_informacao);
  void escreve (int i_coluna, int i_linha, char *cpz_formato,
		float cpz_informacao);

  void poe_mensagem (const char *cpz_mensagem) {
    escreve_esquerda (i_linha_mensagem, cpz_mensagem);
  }

  void apaga_mensagem (void);

  void beep (void);

  void preenche_espacos (char *cpz_linha, const int i_tam);

  int edita_campo (const int i_coluna, const int i_linha,
		   char *cpz_linha, const int i_tam);

  int pega_numero (int i_coluna, int i_linha, int &i_numero,
		   int i_tamanho);

  int pega_numero (int i_coluna, int i_linha, long int &l_numero,
		   int i_tamanho);

  int pega_numero (int i_coluna, int i_linha,
		     float &f_numero, int i_tamanho, int i_casas_dec);

  void mensagem (const char *cpz_mensagem);

  int confirmacao (const char *cpz_mensagem);

  ~tela (void);
};